package tv.danmaku.ijk.media.player;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

//import org.apache.http.client.HttpClient;
//import org.apache.http.impl.client.DefaultHttpClient;

public class IjkHttp {
	
    //NETWORK_GET表示发送GET请求
    public static final String NETWORK_GET = "NETWORK_GET";
    //NETWORK_POST_KEY_VALUE表示用POST发送键值对数据
    public static final String NETWORK_POST_KEY_VALUE = "NETWORK_POST_KEY_VALUE";
	
	 //读取请求头
    private String getReqeustHeader(HttpURLConnection conn) {
        //https://github.com/square/okhttp/blob/master/okhttp-urlconnection/src/main/java/okhttp3/internal/huc/HttpURLConnectionImpl.java#L236
        Map<String, List<String>> requestHeaderMap = conn.getRequestProperties();
        Iterator<String> requestHeaderIterator = requestHeaderMap.keySet().iterator();
        StringBuilder sbRequestHeader = new StringBuilder();
        while (requestHeaderIterator.hasNext()) {
            String requestHeaderKey = requestHeaderIterator.next();
            String requestHeaderValue = conn.getRequestProperty(requestHeaderKey);
            sbRequestHeader.append(requestHeaderKey);
            sbRequestHeader.append(":");
            sbRequestHeader.append(requestHeaderValue);
            sbRequestHeader.append("\n");
        }
        return sbRequestHeader.toString();
    }
    
    //从InputStream中读取数据，转换成byte数组，最后关闭InputStream
    private byte[] getBytesByInputStream(InputStream is) {
        byte[] bytes = null;
        BufferedInputStream bis = new BufferedInputStream(is);
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        BufferedOutputStream bos = new BufferedOutputStream(baos);
        byte[] buffer = new byte[1024 * 8];
        int length = 0;
        try {
            while ((length = bis.read(buffer)) > 0) {
                bos.write(buffer, 0, length);
            }
            bos.flush();
            bytes = baos.toByteArray();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                bos.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                bis.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        return bytes;
    }
    
    //读取响应头
    private String getResponseHeader(HttpURLConnection conn) {
        Map<String, List<String>> responseHeaderMap = conn.getHeaderFields();
        int size = responseHeaderMap.size();
        StringBuilder sbResponseHeader = new StringBuilder();
        for(int i = 0; i < size; i++){
            String responseHeaderKey = conn.getHeaderFieldKey(i);
            String responseHeaderValue = conn.getHeaderField(i);
            sbResponseHeader.append(responseHeaderKey);
            sbResponseHeader.append(":");
            sbResponseHeader.append(responseHeaderValue);
            sbResponseHeader.append("\n");
        }
        return sbResponseHeader.toString();
    }
    
	boolean sendGetReq(final String strContent) 
	{
		new Thread(){
		@Override
			public void run(){
		        try {
		        	URL url = new URL(strContent);
		            HttpURLConnection urlConn=(HttpURLConnection)url.openConnection();
		            int code = urlConn.getResponseCode();
		            
		            urlConn.disconnect();
		        } catch (Exception e) {
		            e.printStackTrace();;
		        } 
			}
		}.start();
			
    //HttpURLConnection默认就是用GET发送请求，所以下面的setRequestMethod可以省略
    //conn.setRequestMethod("GET");
    //HttpURLConnection默认也支持从服务端读取结果流，所以下面的setDoInput也可以省略
    //conn.setDoInput(true);
    //用setRequestProperty方法设置一个自定义的请求头:action，由于后端判断
    //conn.setRequestProperty("action", NETWORK_GET);
    //禁用网络缓存
    //conn.setUseCaches(false);
    //获取请求头
    //String requestHeader = getReqeustHeader(conn);
    //在对各种参数配置完成后，通过调用connect方法建立TCP连接，但是并未真正获取数据
    //conn.connect()方法不必显式调用，当调用conn.getInputStream()方法时内部也会自动调用connect方法
    //conn.connect();
    //调用getInputStream方法后，服务端才会收到请求，并阻塞式地接收服务端返回的数据	
	return true;
	}


	boolean sendPostReq() throws IOException{
//		//HttpClient httpClient = new DefaultHttpClient();
//		  //用POST发送键值对数据
//		URL url = new URL("http://192.168.31.200:8080/HttpServer/MyServlet");
//		HttpURLConnection conn = (HttpURLConnection) url.openConnection();
//		//通过setRequestMethod将conn设置成POST方法
//		conn.setRequestMethod("POST");
//		//调用conn.setDoOutput()方法以显式开启请求体
//		conn.setDoOutput(true);
//		//用setRequestProperty方法设置一个自定义的请求头:action，由于后端判断
//		conn.setRequestProperty("action", NETWORK_POST_KEY_VALUE);
//		//获取请求头
//		String requestHeader = getReqeustHeader(conn);
//		//获取conn的输出流
//		OutputStream os = conn.getOutputStream();
//		//获取两个键值对name=孙群和age=27的字节数组，将该字节数组作为请求体
//		byte[] requestBody = new String("name=孙群&age=27").getBytes("UTF-8");
//		//将请求体写入到conn的输出流中
//		os.write(requestBody);
//		//记得调用输出流的flush方法
//		os.flush();
//		//关闭输出流
//		os.close();
//		//当调用getInputStream方法时才真正将请求体数据上传至服务器
//		InputStream is = conn.getInputStream();
//		//获得响应体的字节数组
//		byte[] responseBody = getBytesByInputStream(is);
//		//获得响应头
//		String responseHeader = getResponseHeader(conn);
		return false;
	}
	
	}


